<script>
import appConfig from '@src/app.config.json'
import Layout from '@layouts/main'
import SaveBtn from "@components/utils/save-btn";
import store from "@state/store";

export default {
  name: "Settings",
  page: {
    title: 'Paramètres',
    meta: [{ name: 'description', content: appConfig.description }],
  },
  components: { Layout, SaveBtn },
  async mounted() {
    await this.getSettings();
  },
  data() {
    return {
      title: 'Paramètres',
      user: store.state.auth.currentUser,
      settings: [],
      all_settings: [],
      all_settings_keys: {
        web_visit_profile: false,
        mail_visit_profile: false,
        web_message: false,
        mail_message: false,
        web_agenda: false,
        mail_agenda: false,
        mail_newsletter: false,
      }
    }
  },
  methods : {
    async saveSettings() {
      const message = await this.$store.dispatch('setting/updateUserSettings', {settings: this.all_settings_keys});
      this.$bvToast.toast(message, {title: 'Succès'});
    },
    async getSettings() {
      this.settings = await this.$store.dispatch('setting/userSettings');
      this.settings.map( setting => {
        this.all_settings_keys[setting.key] = true
      })
    },
    deleteAccount() {
      this.$swal({
        title: 'Etes-vous sure ?',
        text: 'Votre compte sera supprimer de manière définitve',
        showCancelButton: true,
        showCloseButton: true,
        confirmButtonText: 'Comfimer',
        cancelButtonText: 'Annulé',
      }).then( async result => {
        if(result.value){
          await store.dispatch('auth/logOut')
          window.location.href = '/'
        }
      })
    }
  }
}
</script>

<template>
  <Layout :title="title">
    <form @submit.prevent="saveSettings">
      <div class="row">
        <div class="col-md-6 offset-3">
          <b-card>
            <div class="table-responsive">
              <h2>Notifications</h2>
              <table class="table table-borderless mb-0">
                <tbody>
                <tr>
                  <td class="col-6"></td>
                  <td class="col-3">Application</td>
                  <td class="col-3">Mail</td>
                </tr>
                <tr>
                  <td class="col-6">Recevoir les notifications concernant les visites de profils</td>
                  <td class="col-3"><b-form-checkbox v-model="all_settings_keys['web_visit_profile']"></b-form-checkbox></td>
                  <td class="col-3"><b-form-checkbox v-model="all_settings_keys['mail_visit_profile']"></b-form-checkbox></td>
                </tr>
                <tr>
                  <td class="col-6">Recevoir les notifications concernant les messages instantanés</td>
                  <td class="col-3"><b-form-checkbox v-model="all_settings_keys['web_message']"></b-form-checkbox></td>
                  <td class="col-3"><b-form-checkbox v-model="all_settings_keys['mail_message']"></b-form-checkbox></td>
                </tr>
                <tr>
                  <td class="col-6">Recevoir les notifications concernant les rappels de l'agenda</td>
                  <td class="col-3"><b-form-checkbox v-model="all_settings_keys['web_agenda']"></b-form-checkbox></td>
                  <td class="col-3"><b-form-checkbox v-model="all_settings_keys['mail_agenda']"></b-form-checkbox></td>
                </tr>
                </tbody>
              </table>
              <hr>
              <h2>Informations</h2>
              <table class="table table-borderless mb-0">
                <tbody>
                <tr>
                  <td class="col-6">Recevoir la newsletter de Monday Muuv</td>
                  <td class="col-3"></td>
                  <td class="col-3"><b-form-checkbox v-model="all_settings_keys['mail_newsletter']"></b-form-checkbox></td>
                </tr>
                </tbody>
              </table>
            </div>
          </b-card>
        </div>
      </div>
      <b-button @click="deleteAccount" variant="danger" class="text-center d-inline float-left">Supprimer mon compte</b-button>
      <save-btn></save-btn>
    </form>
  </Layout>
</template>
